<?php
defined('BASEPATH') OR exit('No direct script access allowed');
header('Access-Control-Allow-Origin: *'); 

class Client extends CI_Controller {
    public function __construct() 
    {
        parent::__construct();
         $this->load->library('Multiquery'); 
    }
    public function account(){
        $post_data = json_decode(file_get_contents('php://input'), true);
        
        $prefix= @$post_data['searchKey'];
        $supplier = @$post_data['supplier'];
        $distributor =@$post_data['distributor'];
        $spn = "Call ptsl_sp_search_account(?,?,?)";
        $data = $this->db->query($spn,array($supplier,$distributor,$prefix))->result_array();

        if($data){
             $response = array(
                'status' => TRUE,
                'clients' => $data
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function search_account_by_dist(){
        //$post_data = json_decode(file_get_contents('php://input'), true);
        $post_data = json_decode(file_get_contents('php://input'), true);
        
        $prefix= @$post_data['searchKey'];
        $supplier = @$post_data['supplier'];
        $distributor =@$post_data['distributor'];
        $spn = "Call ptsl_sp_search_account(?,?,?)";
        $data = $this->db->query($spn,array($supplier,$distributor,$prefix))->result_array();
        
        if($data){
             $response = array(
                'status' => TRUE,
                'clients' => $data
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function accounts(){
      
        $this->db->select('*');
  
        $data = $this->db->get('ptsl_accountinfo')->result_array();
        
        if($data){
             $response = array(
                'status' => TRUE,
                'clients' => $data
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function account_details($id){
      
        $this->db->select('acc_info.AccountID ,acc_info.LongName,acc_info.ShortName,acc_info.Address, acc_info.Address as address,acc_info.state, acc_info.City,acc_info.BestTimeToVisit,acc_info.SpokeWith,
        acc_info.Zipcode,acc_info.BuyerName,acc_status.AccountStatusName,acc_channel.ChannelName, dis_manager.Dist_managerName,dis_manager.Dist_Manager_Phone,dis_manager.Dist_Manager_Email,dis_rep.Dist_rep_name,dis_rep.Dist_rep_Phone as Phone, dis_rep.Dist_rep_Email as Email');
  	$this->db->where('AccountID',$id);
  	$this->db->from('ptsl_accountinfo as acc_info');
  	$this->db->join('ptsl_accountstatus as acc_status','acc_info.ptsl_accountstatus_AccountStatusID=acc_status.AccountStatusID','left');
  	//$this->db->join('ptsl_accounttype as acc_type','acc_info.ptsl_accounttype_AccountTypeID=acc_type.AccountTypeID','');
  	$this->db->join('ptsl_accountchannel as acc_channel','acc_info.ptsl_accountchannel_accountChannelID=acc_channel.AccountChannelID','left');
  	$this->db->join('ptsl_distributormanager as dis_manager','acc_info.ptsl_DistributorManager_Dist_ManagerID= dis_manager.Dist_ManagerID','left');
  	$this->db->join('ptsl_distributorrep as dis_rep','acc_info.Ptsl_DistributorRep_Dis_rep_id=dis_rep.Dis_rep_id','left');
        $data = $this->db->get()->row();
        $this->db->select('*');
        $this->db->from('ptsl_account_activity');
        $this->db->where('AccountID',$id);
        $this->db->order_by('ActivityID','DESC');
        $this->db->limit(1);

        $data1 = $this->db->get()->row();
        $address = @$data->Address.', '.@$data->City.', '.@$data->state.', '.@$data->Zipcode;
        $newaddress = trim($address,',');
        $data2['address'] = $newaddress;

        //recent sold items
        $this->db->select('InternalAccountID');
        $internal_id_arr  = $this->db->get_where('ptsl_accountinfo',array('AccountID'=>$id))->result_array();
        $internal_id = $internal_id_arr[0]['InternalAccountID'];
        $this->db->select('DATE_FORMAT(tran.ConvertedDate,"%m-%d-%y") as ConvertedDate,tran.units,brand.brand_name,pack.packaging_name');
        $this->db->from('ptsl_sales_transactions tran');
        $this->db->join('ptsl_item_packaging pack','pack.packaging_id = tran.packaging','left');
         $this->db->join('ptsl_item_brand brand','brand.brand_id = tran.brand','left');
        $this->db->where('raw_account_id',$internal_id);
        $this->db->order_by('order_id','DESC');
        $this->db->limit(1);
        $recent_sold_item = $this->db->get()->result_array(); 
        if($recent_sold_item){

            $item = $recent_sold_item[0]['brand_name'].", ".$recent_sold_item[0]['packaging_name'].", Qty ".$recent_sold_item[0]['units'].", ".$recent_sold_item[0]['ConvertedDate'];
        }
        else{
            $item="";
        }
        if($data){
             $response = array(
                'status' => TRUE,
                'client' => $data,
                'recent_activity' =>$data1,
                'address' =>$newaddress,
                'recent_sold_item' => $item
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
     public function account_details_v2($id){
        $this->db->where('AccountID',$id);
        $data = $this->db->get('ptsl_vw_account_info')->row();
        //recent sold items
        /*$this->db->select('InternalAccountID');
        $internal_id_arr  = $this->db->get_where('ptsl_accountinfo',array('AccountID'=>$id))->result_array();
        $internal_id = $internal_id_arr[0]['InternalAccountID'];
        $this->db->select('DATE_FORMAT(tran.ConvertedDate,"%m-%d-%y") as ConvertedDate,tran.units,brand.brand_name,pack.packaging_name');
        $this->db->from('ptsl_sales_transactions tran');
        $this->db->join('ptsl_item_packaging pack','pack.packaging_id = tran.packaging','left');
         $this->db->join('ptsl_item_brand brand','brand.brand_id = tran.brand','left');
        $this->db->where('raw_account_id',$internal_id);
        $this->db->order_by('order_id','DESC');
        $this->db->limit(1);
        $recent_sold_item = $this->db->get()->result_array(); 
        if($recent_sold_item){

            $item = $recent_sold_item[0]['brand_name'].", ".$recent_sold_item[0]['packaging_name'].", Qty ".$recent_sold_item[0]['units'].", ".$recent_sold_item[0]['ConvertedDate'];
        }
        else{
            $item="";
        }*/
        if($data){
             $response = array(
                'status' => TRUE,
                'client' => $data
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function updateAccount(){
       $post_data = json_decode(file_get_contents('php://input'), true);
       //print_r($post_data); exit;
       $buyer = @$post_data['buyer'];
       $spokewith = @$post_data['spokewith'];
       $besttime = @$post_data['besttime'];
       $account_id = @$post_data['account_id'];
       $hasbuyer = @$post_data['hasbuyer'];
       $hasSpokewith = @$post_data['hasspokewith'];
       $hasbest = @$post_data['hasbest'];
       $BestTimeToVisit_day = @$post_data['day'];
       $best_time_to_visit_time = @$post_data['time'];
      /* $data = array(
            'BuyerName' => $buyer,
            'SpokeWith' => $spokewith,
            'BestTimeToVisit' => $besttime
        );*/
        $data = array();
        if($hasSpokewith){
            $data['SpokeWith'] = $spokewith;
        }
       if($hasbuyer){
            $data['BuyerName'] = $buyer;
        }
       if($hasbest){
            if($best_time_to_visit_time){
                $data['best_time_to_visit_time'] = $best_time_to_visit_time;
            }
            if($BestTimeToVisit_day){
                $data['BestTimeToVisit_day'] = $BestTimeToVisit_day;
            }
        }   
       $this->db->where('AccountID',$account_id);
       $res = $this->db->update('ptsl_accountinfo',$data);
       if($res){
             $response = array(
                'status' => TRUE,
                'message' => 'Data Updated Successfully'
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        } 
    }
    public function updateAccount_dist(){
       $post_data = json_decode(file_get_contents('php://input'), true);
       //print_r($post_data); exit;
       $buyer = @$post_data['buyer2'];
       $notes = @$post_data['notes'];
       $besttime = @$post_data['time'];
       $day = @$post_data['day'];
       $account_id = @$post_data['account_id'];
       $hasbuyer = @$post_data['hasbuyer'];
       $hasnote = @$post_data['hasnote'];
       //$hasbesttime = @$post_data['hasbesttime'];
      /* $data = array(
            'BuyerName' => $buyer,
            'SpokeWith' => $spokewith,
            'BestTimeToVisit' => $besttime
        );*/
        $data = array();
        if($hasnote){
            $data['dist_notes'] = $notes;
        }
       if($hasbuyer){
            $data['dist_buyer'] = $buyer;
        }
       if($day){
            $data['dist_best_time_to_visit_day'] = $day;
        }
        if($besttime){
            $data['dist_best_time_to_visit_time'] = $besttime;
        }   
       $this->db->where('AccountID',$account_id);
       $res = $this->db->update('ptsl_accountinfo',$data);
       if($res){
             $response = array(
                'status' => TRUE,
                'message' => 'Data Updated Successfully'
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        } 
    }
    public function get_account_type(){
    	$this->db->select('*');
    	$data = $this->db->get('ptsl_accounttype')->result_array();
    	//echo json_encode($data);
    	if($data){
             $response = array(
                'status' => TRUE,
                'account_type' => $data
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
     public function get_activity_type(){
    	$this->db->select('*');
    	$data = $this->db->get('ptsl_activitytype')->result_array();
    	
    	//echo json_encode($data);
    	if($data){
             $response = array(
                'status' => TRUE,
                'acitivity_type' => $data
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
     public function get_activity($client_id){
        /*$this->db->select('LEFT(acc.spokewith,7) as spokewith,DATE_FORMAT(acc.ActivityDate,"%m-%d-%y") as ActivityDate,acc.Notes,acc.BestTimeToVisit_day, 		
 subevent.SubTypeName as SubTypeName,accinfo.LongName,acc.isEvent,acc.ActivityID');*/
        //$this->db->from('ptsl_account_activity as acc');
        //$this->db->join('ptsl_accountinfo as accinfo','acc.AccountID=accinfo.AccountID');
     //   $this->db->join('ptsl_activitytype as event','acc.ActivityTypeID=event.ActivityTypeID','');
       // $this->db->join('ptsl_activitysubtype as subevent','acc.ptsl_activitySubtype_ActivitySubtypeID=subevent.ActivitySubtypeID','');
  $this->db->select('LEFT(spokewith,7) as spokewith,DATE_FORMAT(ActivityDate,"%c-%e-%y") as ActivityDate,Notes,BestTimeToVisit_day,supplier_name,       
 SubTypeName as SubTypeName,LongName,isEvent,ActivityID');
        $this->db->from('ptsl_vw_account_activity');
        $this->db->where('AccountID',$client_id);
        $this->db->order_by('ActivityID','desc');
        $this->db->limit(5);
    	$data = $this->db->get()->result_array();
    	$this->db->select('count(ActivityID) as total_activity');
        $total_activity_arr = $this->db->get_where('ptsl_account_activity',array('AccountID'=>$client_id))->result_array();
        $total_activity = 0;
        if($total_activity_arr){
            $total_activity = $total_activity_arr[0]['total_activity'];
        }
    	if($data){
             $response = array(
                'status' => TRUE,
                'activites' => $data,
                'total_activity'=> $total_activity
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function get_activity_dist($client_id){
        $this->db->select('LEFT(spokewith,7) as spokewith,DATE_FORMAT(ActivityDate,"%c-%e-%y") as ActivityDate,Notes,BestTimeToVisit_day,supplier_name,       
 SubTypeName as SubTypeName,LongName,isEvent,ActivityID');
        $this->db->from('ptsl_vw_account_activity');
        /*$this->db->from('ptsl_account_activity as acc');
        $this->db->join('ptsl_accountinfo as accinfo','acc.AccountID=accinfo.AccountID');
     //   $this->db->join('ptsl_activitytype as event','acc.ActivityTypeID=event.ActivityTypeID','');
        $this->db->join('ptsl_activitysubtype as subevent','acc.ptsl_activitySubtype_ActivitySubtypeID=subevent.ActivitySubtypeID','');
        $this->db->join('ptsl_supplier sup','sup.id=accinfo.supplier_id','left');
        $this->db->where('acc.AccountID',$client_id);
        $this->db->order_by('acc.ActivityID','desc');
        $this->db->limit(5);*/
         $this->db->where('AccountID',$client_id);
        $this->db->order_by('ActivityID','desc');
        $this->db->limit(5);
        $data = $this->db->get()->result_array();
        
        $this->db->select('count(ActivityID) as total_activity');
        $total_activity_arr = $this->db->get_where('ptsl_account_activity',array('AccountID'=>$client_id))->result_array();
        $total_activity = 0;
        if($total_activity_arr){
            $total_activity = $total_activity_arr[0]['total_activity'];
        }
        if($data){
             $response = array(
                'status' => TRUE,
                'activites' => $data,
                'total_activity'=> $total_activity
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function get_sale($id){
        $this->db->select("DATE_FORMAT(ConvertedDate,'%c-%e-%y') as ConvertedDate,ceil(units) as units, sku");
        $this->db->from('ptsl_vw_sales_transaction');
        $this->db->where('account_id',$id);
        $this->db->order_by('order_id','DESC');
        $this->db->limit(5);
        $data = $this->db->get()->result_array(); 
        //echo $this->db->last_query();
        
        if($data){
             $response = array(
                'status' => TRUE,
                'sales' => $data
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }

    }
    public function get_sale_by_acitivty_id($id){
        $this->db->select('AccountID');
        $data_row = $this->db->get_where('ptsl_account_activity',array('ActivityID'=> $id))->row();
        $AccountID = $data_row->AccountID;
        $this->db->select('InternalAccountID');
        $internal_id_arr  = $this->db->get_where('ptsl_accountinfo',array('AccountID'=>$AccountID))->result_array();
        $internal_id = $internal_id_arr[0]['InternalAccountID'];

        $this->db->select("DATE_FORMAT(tran.ConvertedDate,'%m-%d-%y') as ConvertedDate,tran.units, brand.brand_name as brand");
        $this->db->from('ptsl_sales_transactions tran');
        $this->db->join('ptsl_item_packaging pack','pack.packaging_id = tran.packaging','left');
        $this->db->join('ptsl_item_brand brand','brand.brand_id = tran.brand','left');
        $this->db->where('raw_account_id',$internal_id);
        $this->db->order_by('order_id','DESC');
        $this->db->limit(5);
        $data = $this->db->get()->result_array(); 
        //echo $this->db->last_query();
        
        if($data){
             $response = array(
                'status' => TRUE,
                'sales' => $data
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }

    }
     public function get_activity_subtype(){
    	$this->db->select('ActivitySubtypeID as id, SubTypeName as name');
        $this->db->where('Ptsl_ActivityType_ActivityTypeID',1);
    	$data = $this->db->get('ptsl_activitysubtype')->result_array();
    	//echo $this->db->last_query();
    	//echo json_encode($data);
    	if($data){
             $response = array(
                'status' => TRUE,
                'event_subtypes' => $data
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
     public function get_participants(){
        $user_id = @$this->input->get('userid');
        $supplier = @$this->input->get('supplier');
        $spn = "Call ptsl_sp_get_participants_list('".$supplier."')";   
        $data = $this->db->query($spn)->result_array();     
        foreach ($data as $key => $d) {
           $manupulated_array[$key]['id'] = $d['user_id'];
           $manupulated_array[$key]['name'] = $d['user_name'];
           if($d['user_id'] == $user_id){
            $manupulated_array[$key]['selected'] = true;

           }
           
        }
        if($data){
             $response = array(
               // 'status' => TRUE,
                'users' => $manupulated_array
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    
    public function get_participants_foredit($id,$supplier){
        $modified_participants =array();
        $this->db->select('ParticipantID');
        $participants = @$this->db->get_where('ptsl_activity_participants',array('ActivityID'=>$id))->result_array();
        foreach ($participants as  $participant) {
           array_push ($modified_participants,$participant['ParticipantID']);
        }
        $spn = "Call ptsl_sp_get_participants_list('".$supplier."')";   
        $data = $this->db->query($spn)->result_array();  
        foreach ($data as $key => $d) {
           $manupulated_array[$key]['id'] = $d['user_id'];
           $manupulated_array[$key]['name'] = $d['user_name'];
           if($participants && (in_array($d['user_id'], $modified_participants))){
            $manupulated_array[$key]['selected'] = true;
           }
           
        }
        if($data){
             $response = array(
               // 'status' => TRUE,
                'users' => $manupulated_array
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function accountinfoForNewActivity($id){
        $data = $this->db->get_where('ptsl_accountinfo',array('AccountID'=>$id))->result_array();
        if($data){
             $response = array(
                'status' => TRUE,
                'info' => $data[0]
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function addactivity(){
    	$post_data = json_decode(file_get_contents('php://input'), true);
    	
    	$Buyer = @$post_data['buyer'];
    	$spokewith = @$post_data['spokewith'];
    	$InternalNotes = @$post_data['internal_note'];
    	$notes = @$post_data['note'];
    	$BrandExposure = @$post_data['brand'];
    	$DecisionMaker = @$post_data['decession'];
    	$BestTimeToVisit_day = @$post_data['day'];
        $best_time_to_visit_time = @$post_data['time'];
    	$CreatedBy = @$post_data['user_id'];
        $user_id = $CreatedBy;
    	//$Client_Rep_ID = @$post_data['supplier_rep_id'];
    	$CreatedDate = date('Y-m-d');
    	$ptsl_accountinfo_AccountID = @$post_data['account_id'];
    	//multiple accout rep id 
    	$participants = @$post_data['participants'];
        $ptsl_activitySubtype_ActivitySubtypeID = 1;
        $ptsl_activitySubtype_ActivitySubtypeID = @$post_data['subtype'];
        $is_dist_action_needed = @$post_data['distAction'];
        $is_supplier_action_needed = @$post_data['suppAction'];
        $additinal_detail = @$post_data['additinal_detail'];
    	if(!$ptsl_activitySubtype_ActivitySubtypeID){
    		$ptsl_activitySubtype_ActivitySubtypeID = 2;
    	}else{
    	    //$this->db->get_where()->result_array();
        	$ActivityDate = date('Y-m-d');
        	$data = array(
        		//'ActivityTypeID' => $ActivityTypeID,
        		'Buyer'          => $Buyer,
        		'spokewith'      => $spokewith,
        		'InternalNotes'  => $InternalNotes,
        		'Notes'          => $notes,
        		'BestTimeToVisit_day'=> $BestTimeToVisit_day,
                'best_time_to_visit_time'=> $best_time_to_visit_time,
        		'BrandExposure'  => $BrandExposure,
        		'DecisionMaker'  => $DecisionMaker,
        		'CreatedBy'      => $CreatedBy,
        		'CreatedDate'    => $CreatedDate,
        		'ActivityDate'	 => $ActivityDate,	
        		'user_id'  => $user_id,
                'is_dist_action_needed'=> $is_dist_action_needed,
                'is_supplier_action_needed' => $is_supplier_action_needed,		
        		//'ActivityImage'  => $ActivityImage,
                'aditional_detail' => $additinal_detail,
        		'ptsl_activitySubtype_ActivitySubtypeID'=> $ptsl_activitySubtype_ActivitySubtypeID,
        		'AccountID' => $ptsl_accountinfo_AccountID
        	);
        	$add_activity = $this->db->insert('ptsl_account_activity',$data);
        	$acitivity_id = $this->db->insert_id();
            //update into accouninfo table 
            $data = array(
                'BuyerName' => $Buyer,
                'SpokeWith' => $spokewith,
                'BestTimeToVisit_day' => $BestTimeToVisit_day,
                'best_time_to_visit_time'=> $best_time_to_visit_time
            );
           $this->db->where('AccountID',$ptsl_accountinfo_AccountID);
           $res = $this->db->update('ptsl_accountinfo',$data);
        	//participants
        	if($participants){
            foreach($participants as $participant){
                if(@$participant['selected'] == 1){
                    $data2= array(
                        'ActivityID' => $acitivity_id,
                        'ParticipantID' => $participant['id']
                    );
                    $res = $this->db->insert('ptsl_activity_participants',$data2);
                }

            }
        }
            if(@$post_data['photos']){    
                $images = $post_data['photos'];
                $photo_taken_date = date("Y-m-d H:i:s");
                foreach ($images as $key => $image) {
                    $loc="../accountapi/temp/img".date('YmdHis');
                    $imgData1 = $image;
                    $imgData1 = substr($imgData1, 1+strrpos($imgData1, ','));
                    //$sourceFilename = 'http://periscopedemo.com/accountapi_dev/temp/imgMyFile.jpg';
                    file_put_contents($loc.'MyFile.jpg', base64_decode($imgData1));
                    $image_file=$loc.'MyFile.jpg';
                    $target_file = $image_file;
                    $thumbnail = "../accountapi/thumb/".date('YmdHis')."file.jpg";
                    $wthumb = 100;
                    $hthumb = 100;
                    $fileExt="jpg";
                    $this->ak_img_thumb($target_file, $thumbnail, $wthumb, $hthumb, $fileExt);
                    $encoded_thumb = base64_encode(file_get_contents($thumbnail));
                    $jpg_encoded_thumb = "data:image/jpeg;base64,".$encoded_thumb;
                    unlink($thumbnail); 
                    $data_img = array(
                            'ActivityID' => $acitivity_id,
                            'Photo' => $image,
                            'thumbnail' => $jpg_encoded_thumb,
                            'taken_date' => $photo_taken_date,
                            'user_id' => $CreatedBy
                        );
                    $res = $this->db->insert('ptsl_activity_photos',$data_img); 
                }
            }
        	if($add_activity){
        		$response = array(
        			'status' => TRUE,
                    'activity_id' => $acitivity_id,
        			'message'=> "Visit Inserted Successfully"
        		);
        		echo json_encode($response);
        	}
        	else{
        		$response = array(
        			'status' => FALSE,
        			'message'=> "Internal Error"
        		);
        		echo json_encode($response);	
        	}
        }
    }
    public function updateactivity(){
        $post_data = json_decode(file_get_contents('php://input'), true);
        
        $Buyer = @$post_data['buyer'];
        $spokewith = trim(@$post_data['spokewith']);
        $InternalNotes = @$post_data['internal_note'];
        $notes = @$post_data['note'];
        $BrandExposure = @$post_data['brand'];
        $DecisionMaker = @$post_data['decession'];
        $BestTimeToVisit_day = @$post_data['day'];
        $best_time_to_visit_time = @$post_data['time'];
        $CreatedBy = @$post_data['user_id'];
        $user_id = $CreatedBy;
        //$Client_Rep_ID = @$post_data['supplier_rep_id'];
        $UpdatedDate = date('Y-m-d');
        //$ActivityImage = @$post_data['image'];
        $ptsl_accountinfo_AccountID = @$post_data['account_id'];
        $ptsl_activitySubtype_ActivitySubtypeID = @$post_data['subtype'];
        $activity_id = @$post_data['activity_id'];
        //multiple accout rep id 
        $participants = @$post_data['participants'];
        $is_dist_action_needed = @$post_data['distAction'];
        $is_supplier_action_needed = @$post_data['suppAction'];
        $additinal_detail = @$post_data['additinal_detail'];
        
            $ActivityDate = date('Y-m-d');
            $data = array(
                //'ActivityTypeID' => $ActivityTypeID,
                'aditional_detail' => $additinal_detail,
                'UpdatedBy'      => $CreatedBy,
                'UpdatedDate'    => $UpdatedDate, 
                        
            );
            if(@$additinal_detail){
                $data['aditional_detail']= $additinal_detail;
            }
            if(@$ptsl_activitySubtype_ActivitySubtypeID){
                $data['ptsl_activitySubtype_ActivitySubtypeID']= $ptsl_activitySubtype_ActivitySubtypeID;
            }
            if(@$Buyer){
                $data['Buyer'] = $Buyer;
            }
            if(@$spokewith){
                $data['spokewith'] = $spokewith;
            }
            if(@$InternalNotes){
                $data['InternalNotes'] = $InternalNotes;
            }
            if(@$notes){
                $data['Notes'] = $notes;
            }
            if(@$BestTimeToVisit_day){
                $data['BestTimeToVisit_day'] = $BestTimeToVisit_day;
            }
            if(@$best_time_to_visit_time){
                $data['best_time_to_visit_time'] = $best_time_to_visit_time;
            }
            if(@$DecisionMaker){
                $data['DecisionMaker'] = $DecisionMaker;
            }
            if(@$BrandExposure){
                $data['BrandExposure'] = $BrandExposure;
            }
            $data['is_dist_action_needed'] = $is_dist_action_needed;
            $data['is_supplier_action_needed'] = $is_supplier_action_needed;
            $this->db->where('ActivityID',$activity_id);
            $add_activity = $this->db->update('ptsl_account_activity',$data);
            //$acitivity_id = $this->db->insert_id();
            //update into accouninfo table 
            /*$data = array(
                'BuyerName' => $Buyer,
                'SpokeWith' => $spokewith,
                'BestTimeToVisit' => $BestTimeToVisit
            );
           $this->db->where('AccountID',$ptsl_accountinfo_AccountID);
           $res = $this->db->update('ptsl_accountinfo',$data);*/
           $data = array(
                'BuyerName' => $Buyer,
                'SpokeWith' => $spokewith,
                'BestTimeToVisit_day' => $BestTimeToVisit_day,
                'best_time_to_visit_time'=> $best_time_to_visit_time
            );
           $this->db->where('AccountID',$ptsl_accountinfo_AccountID);
           $res = $this->db->update('ptsl_accountinfo',$data);
            if($participants){
                $is_valid_to_delete= 0;
                foreach($participants as $participant){
                    if(@$participant['selected'] == 1){
                        $is_valid_to_delete = 1;
                        break;
                    }
                }
                if($is_valid_to_delete){
                    $this->db->where('ActivityID',$activity_id);
                    $this->db->delete('ptsl_activity_participants');
                }
            
            foreach($participants as $participant){
                if(@$participant['selected'] == 1){
                    $data2= array(
                        'ActivityID' => $activity_id,
                        'ParticipantID' => $participant['id']
                    );
                    $res = $this->db->insert('ptsl_activity_participants',$data2);
                }

            }
        }

            if(@$post_data['photos']){
               /* $this->db->where('ActivityID',$activity_id);
                $this->db->delete('ptsl_activity_photos'); */   
                $images = $post_data['photos'];
                $photo_taken_date = date("Y-m-d H:i:s");
                foreach ($images as $key => $image) {
                    $loc="../accountapi_dev/temp/img".date('YmdHis');
                    $imgData1 = $image;
                    $imgData1 = substr($imgData1, 1+strrpos($imgData1, ','));
                    $sourceFilename = 'http://periscopedemo.com/accountapi_dev/temp/imgMyFile.jpg';
                    file_put_contents($loc.'MyFile.jpg', base64_decode($imgData1));
                    $image_file=$loc.'MyFile.jpg';
                    $target_file = $image_file;
                    $thumbnail = "../accountapi_dev/thumb/".date('YmdHis')."file.jpg";
                    $wthumb = 100;
                    $hthumb = 100;
                    $fileExt="jpg";
                    $this->ak_img_thumb($target_file, $thumbnail, $wthumb, $hthumb, $fileExt);
                    $encoded_thumb = base64_encode(file_get_contents($thumbnail));
                    $jpg_encoded_thumb = "data:image/jpeg;base64,".$encoded_thumb;
                    unlink($thumbnail);  
                    $data_img = array(
                            'ActivityID' => $activity_id,
                            'Photo' => $image,
                            'thumbnail' => $jpg_encoded_thumb,
                            'taken_date' => $photo_taken_date,
                            'user_id' => $CreatedBy
                        );
                    $res = $this->db->insert('ptsl_activity_photos',$data_img); 
                }
            }
            if($add_activity){
                $response = array(
                    'status' => TRUE,
                    'message'=> "Visit Updated Successfully"
                );
                echo json_encode($response);
            }
            else{
                $response = array(
                    'status' => FALSE,
                    'message'=> "Internal Error"
                );
                echo json_encode($response);    
            }
        
    }
    public function get_accountname($id){
    	$this->db->select("acc_info.LongName,concat_ws(
    ', ',
    nullif( `acc_info`.`Address`, '' ),
    nullif( `acc_info`.`City`, '' ),
    nullif( `acc_info`.`state`, '' ),
    nullif( `acc_info`.`Zipcode`, '' ) 
    ) AS `full_address`");
    	$data = $this->db->get_where('ptsl_accountinfo acc_info',array('AccountID'=>$id))->result_array();
    	if($data){
             $response = array(
                'status' => TRUE,
                'name' => $data
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function get_activity_details($id,$user_id){
    	$this->db->select('*');
    	$this->db->from('ptsl_vw_account_activity');
    	$this->db->where('ActivityID',$id);
    	$data['activity'] = $this->db->get()->row();
        $photos_id_array =array();
    	if($data){
            $sql = "select ptsl_fn_get_participants_comma('".$id."') as participants;";
            $participants = $this->db->query($sql)->row();
            $data['participant_names'] = $participants->participants;
            $spn = "Call ptsl_sp_get_photos_activity('".$user_id."','".$id."')";
            $data_photos = $this->multiquery->GetResults($spn); 
            $new_array = array(); 
            foreach($data_photos[1] as $key=>$adata){
                $new_array[$key]['id'] =$key;
                $photos_id_array[$key]['PhotoID'] = $adata['PhotoID'];
                $new_array[$key]['src'] = $adata['thumbnail'];
                $new_array[$key]['ActivityID'] = $adata['ActivityID'];
                $new_array[$key]['title'] = $adata['photo_title'];
                $new_array[$key]['number_of_comments'] = $adata['number_of_comments'];
            }
           
            $response= array(
                'status' => TRUE,
                'acitivity' => $data,
                'photos' => $new_array,
                'photos_id' =>$photos_id_array
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function getPhotosidbyActivityid($id){
        $this->db->select('p.PhotoID');
        //$this->db->where('PhotoID',$photoid);
        $this->db->from('ptsl_activity_photos p');
        $this->db->join('ptsl_account_activity a','p.ActivityID=a.ActivityID','');
        $this->db->where('a.ActivityID',$id);
        $this->db->where('p.thumbnail!=""');
        $data = $this->db->get()->result_array();
        if($data){
          $response= array(
                'status' => TRUE,
                'photos_id' => $data  
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status'=> FALSE,
                'message'=> 'No data found'
            );
            echo json_encode($response);
        }
    }
    public function get_activity_details_edit($id){
        $this->db->select("acc.AccountID,acc.LongName,stype.SubTypeName,act.ActivityID,act.Buyer,act.spokewith,act.InternalNotes,act.Notes,act.ActivityDate,act.BrandExposure,act.DecisionMaker,act.BestTimeToVisit_day,act.best_time_to_visit_time,act.is_dist_action_needed,act.is_supplier_action_needed,act.aditional_detail,
            concat_ws(
    ', ',
    nullif( `acc`.`Address`, '' ),
    nullif( `acc`.`City`, '' ),
    nullif( `acc`.`state`, '' ),
    nullif( `acc`.`Zipcode`, '' ) 
    ) AS `full_address`
    ");
        $this->db->from('ptsl_account_activity act');
        $this->db->join('ptsl_accountinfo acc','acc.AccountID = act.AccountID');
        //$this->db->join('ptsl_activitytype as type','act.ActivityTypeID=type.ActivityTypeID','');
        $this->db->join('ptsl_activitysubtype as stype','act.ptsl_activitySubtype_ActivitySubtypeID=stype.ActivitySubtypeID','');
        //$this->db->join('ptsl_activity_photos',);
        $this->db->where('act.ActivityID',$id);
        $data['activity'] = $this->db->get()->row();
        if($data){
           // $this->db->select('photo');
            //$this->db->where('ActivityID',$id);
            //$photos = $this->db->get('ptsl_activity_photos')->result_array();
            $this->db->select('rep.ClientRepName as name,par.ParticipantID');
            $this->db->join('ptsl_clientrep rep','rep.ClientRepID = par.ParticipantID');
            $this->db->where('par.ActivityID',$id);
            $participants = $this->db->get('ptsl_activity_participants par')->result_array();
            $part_names = "";
            foreach($participants as $participant){
                $part_names = $part_names.$participant['name'].", ";
            }
            $selected_part_name = trim($part_names, ',');
            $data['par_names'] = $selected_part_name;
            $data['participants'] = $participants;
             $response = array(
                'status' => TRUE,
                'activity' => $data
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    private function ak_img_thumb($target, $newcopy, $w, $h, $ext) {
        list($w_orig, $h_orig) = getimagesize($target);
        $src_x = ($w_orig / 2) - ($w / 2);
        $src_y = ($h_orig / 2) - ($h / 2);
        $ext = strtolower($ext);
        $img = "";
        if ($ext == "gif"){ 
        $img = imagecreatefromgif($target);
        } else if($ext =="png"){ 
        $img = imagecreatefrompng($target);
        } else { 
        $img = imagecreatefromjpeg($target);
        }
        $tci = imagecreatetruecolor($w, $h);
        //imagecopyresampled($tci, $img, 0, 0, $src_x, $src_y, $w, $h, $w_orig, $h_orig);
        imagecopyresampled($tci, $img, 0, 0, 0, 0, $w, $h, $w_orig, $h_orig);
        if ($ext == "gif"){ 
            imagegif($tci, $newcopy);
        } else if($ext =="png"){ 
            imagepng($tci, $newcopy);
        } else { 
           $t= imagejpeg($tci, $newcopy, 84);
           //echo base64_encode($t);

        }
       //echo base64_encode($target);
    }
}