<?php
defined('BASEPATH') OR exit('No direct script access allowed');
header('Access-Control-Allow-Origin: *'); 

class Engage extends CI_Controller {
    public function __construct() 
    {
        parent::__construct();
        
    }
    public function index(){
    	$this->db->where('isactive',1);
    	$result = $this->db->get('ptsl_engagementconfig')->result_array();
    	if($result){
             $response = array(
                'status' => TRUE,
                'engagements' => $result
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        	echo json_encode($response);
        }
    }
    public function pending($userid){
        $iscompleted = 0;
        $isoverdue=0;
        $sql = "call ptsl_sp_get_todo(?,?,?)";
        $result = $this->db->query($sql,array($userid,$iscompleted,$isoverdue))->result_array();
    	if($result){
             $response = array(
                'status' => TRUE,
                'pending_todo' => $result
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        	echo json_encode($response);
        }
    }
    public function completed($userid){
        $iscompleted = 1;
        $isoverdue=0;
        $sql = "call ptsl_sp_get_todo(?,?,?)";
        $result = $this->db->query($sql,array($userid,$iscompleted,$isoverdue))->result_array();
    	if($result){
             $response = array(
                'status' => TRUE,
                'completed_todo' => $result
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        	echo json_encode($response);
        }
    }
    public function acc_completed($account_id){
        $this->db->select('date_format(completiondate, "%c-%e-%y") as date,econfig.value');
        $this->db->from('ptsl_account_todolist todo');
        $this->db->join('ptsl_engagementconfig econfig','econfig.engagementid=todo.engagementid','');
        $this->db->where('todo.accountid',$account_id);
        $this->db->where('todo.iscompleted',1);
        $this->db->limit(5);
        $this->db->order_by('todo.id desc');
        $result = $this->db->get()->result_array();
        if($result){
             $response = array(
                'status' => TRUE,
                'completed_todos' => $result
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
            echo json_encode($response);
        }
    }
    public function overdue($userid){
        $iscompleted = 0;
        $isoverdue=1;
        $sql = "call ptsl_sp_get_todo(?,?,?)";
        $result = $this->db->query($sql,array($userid,$iscompleted,$isoverdue))->result_array();
        if($result){
             $response = array(
                'status' => TRUE,
                'overdue_todo' => $result
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
            echo json_encode($response);
        }
    }
    public function changestatus($id){
        $data= array(
            'iscompleted' =>1,
            'completiondate'=> date('Y-m-d')
        );
        $this->db->where('id',$id);
        $res = $this->db->update('ptsl_account_todolist',$data);
        if($res){
            $response = array(
                'status' => TRUE,
                'message' => 'Success'
            );
            echo json_encode($response);
        }
    }
    public function delete($id){
     	
    	$this->db->where('id',$id);
    	$result = $this->db->delete('ptsl_account_todolist');
    	if($result){
             $response = array(
                'status' => TRUE,
                'message' => 'Deleted Successfully'
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        	echo json_encode($response);
        }
    }
    public function add(){
        $post_data = json_decode(file_get_contents('php://input'), true);
     //   print_r($post_data);
        $ids = $post_data['ids'];
        $user_id = $post_data['user_id'];
        $client_id = @$post_data['accountid'];
        $cleint_rep_id = $post_data['supplier_rep_id'];
        $other_text = @$post_data['othertext'];
        $due_date = @$post_data['duedate'];
        if($ids){
            foreach ($ids as $id) {

                $data = array(
                    'accountid' => $client_id,
                    'engagementid' => $id,
                    'iscompleted' => 0,
                    'initiationdate' => date('Y-m-d'),
                    'clientrepid' => $cleint_rep_id,
                    'user_id' => $user_id,
                    'due_date' => $due_date,
                );
                if($id ==5){
                    $data['other_text'] = @$other_text;
                }
                $res= $this->db->insert('ptsl_account_todolist',$data);
            }
            $response = array(
                'status' => TRUE,
                'message' => "Data inserted"
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status' => False,
                'message' => "Please select atleast one option"
            );
            echo json_encode($response);
        }
    }
}