<?php
defined('BASEPATH') OR exit('No direct script access allowed');
header('Access-Control-Allow-Origin: *'); 

class Report extends CI_Controller {
    public function __construct() 
    {
    	//error_reporting(0);
        parent::__construct();  
    }
    public function index(){
    	//$href_array = array("#/TopOnPremise/","#/TopOffPremise/","#/TopDrafts/","#/lostaccounts/","#/brandreportinit/","#/statereportinit/","#/permisereportinit/","#/skureportinit/","#/activityreport/","#/brandexpreport/","#/recentactreport/");
        $this->db->order_by('group');
    	$reports = $this->db->query('select distinct(`group`) as gr_ from ptsl_report_config')->result_array();
    	foreach ($reports as $key => $report) {
            $this->db->order_by('report_order');
            $new_arr = $this->db->get_where('ptsl_report_config',array('group'=>$report['gr_']))->result_array();
            //echo $this->db->last_query();
            foreach ($new_arr as $key2 => $value) {
                $data[$key2]['report_name'] = $value['report_name'];
            $data[$key2]['report_id'] = $value['report_id'];
            $data[$key2]['href'] = '#/'.$value['url'].'/';
                
            }
    		$data_arr[$key]['group'] = $report['gr_'];
            $data_arr[$key]['reports'] = $data;
            $data = array();
    	}
    	if($data_arr){
             $response = array(
                'status' => TRUE,
                'reports' => $data_arr
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function getDistributor(){
        $this->db->select('DistributorID,Name');
        $data = $this->db->get('ptsl_distributor')->result_array();
        $months =  $this->db->get('months')->result_array();
        if($data){
             $response = array(
                'status' => TRUE,
                'distributors' => $data,
                'months'=> $months
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function TopOnPremise(){
    	$months = @$this->input->get('months');
    	$years  = @$this->input->get('years');
    	$distributor  = @$this->input->get('distributor');
    	if(!$months){
    		$this->db->select('default_month');
    		$months_array = @$this->db->get_where('ptsl_report_config',array("report_id"=>1))->result_array();
    		$months = $months_array[0]['default_month'];
    	}
    	if(!$years){
    		$this->db->select('default_year');
    		$years_array = @$this->db->get('ptsl_report_config',array("report_id"=>1))->result_array();
    		$years = $years_array[0]['default_year'];
    	}
    	if(!$distributor){
    		$this->db->select('default_distributor');
    		$distributor_array = @$this->db->get('ptsl_report_config',array("report_id"=>1))->result_array();
    		$distributor = $distributor_array[0]['default_distributor'];
    	}

    	$sql = "SELECT

                sls.raw_account_id,
                sls.raw_distributor_manager as manager,
                SUM(case_equivalents) as CE,

                acc.AccountID,
                acc.latitude,
                acc.longitude,
                acc.LongName,

                concat_ws(' ',acc.Address,acc.state,acc.City,acc.Zipcode) as address,

                rep.ClientRepName

				FROM ptsl_sales_transactions sls

				LEFT OUTER JOIN ptsl_accountinfo acc on acc.InternalAccountID = sls.raw_account_id

				LEFT OUTER JOIN ptsl_clientrep rep on rep.ClientRepID = sls.client_rep_id

				where sls.channel = 1";

		if(@$months){
			$sql = $sql." and month(ConvertedDate) in (".$months.")";
		}
		if(@$years){
			$sql = $sql." and YEAR(ConvertedDate) in (".$years.")";
		}
		if(@$distributor){
			$sql = $sql. " and sls.distributor_id=".$distributor;
		}
		$sql = $sql. " and container_id = 1";

 		$sql = $sql." group by sls.raw_account_id, acc.AccountID,acc.LongName,rep.ClientRepName order by CE desc";
 		$data = $this->db->query($sql)->result_array();
        $geocode_array = array();
        $cnt = 0;
        $len=count($data);
        foreach ($data as $key => $account) {
            if($account['latitude']){
                $address = $account['address'];
                $name = $account['LongName'];
                $link = '<div class="sum2">'.'<a href="#/clientresult/'.$account["AccountID"].'">Go to Account</a></div>';
                $geocode_array[$cnt][0] = '<div class="summary">'.$name.'</div>'.'<br /><br />'.$address.'<br/><br/>'.$link;
                $geocode_array[$cnt][1] = $account['latitude'];
                $geocode_array[$cnt][2] = $account['longitude'];
                $cnt++;
            }
        }
 		if($data){
             $response = array(
                'status' => TRUE,
                'TopOnPremisereports' => $data,
                'locations' => $geocode_array,
                'len' => count($geocode_array)
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function TopOffPremise(){
    	$months = @$this->input->get('months');
    	$years  = @$this->input->get('years');
    	$distributor  = @$this->input->get('distributor');
    	if(!$months){
    		$this->db->select('default_month');
    		$months_array = @$this->db->get_where('ptsl_report_config',array("report_id"=>2))->result_array();
    		$months = $months_array[0]['default_month'];
    	}
    	if(!$years){
    		$this->db->select('default_year');
    		$years_array = @$this->db->get('ptsl_report_config',array("report_id"=>2))->result_array();
    		$years = $years_array[0]['default_year'];
    	}
    	if(!$distributor){
    		$this->db->select('default_distributor');
    		$distributor_array = @$this->db->get('ptsl_report_config',array("report_id"=>2))->result_array();
    		$distributor = $distributor_array[0]['default_distributor'];
    	}

    	$sql = "SELECT

                sls.raw_account_id,
                sls.raw_distributor_manager as manager,
                SUM(case_equivalents) as CE,

                acc.AccountID,

                acc.LongName,
                acc.latitude,
                acc.longitude,
                concat_ws(' ',acc.Address,acc.state,acc.City,acc.Zipcode) as address,

                rep.ClientRepName

				FROM ptsl_sales_transactions sls

				LEFT OUTER JOIN ptsl_accountinfo acc on acc.InternalAccountID = sls.raw_account_id

				LEFT OUTER JOIN ptsl_clientrep rep on rep.ClientRepID = sls.client_rep_id

				where sls.channel = 2";

		if(@$months){
			$sql = $sql." and month(ConvertedDate) in (".$months.")";
		}
		if(@$years){
			$sql = $sql." and YEAR(ConvertedDate) in (".$years.")";
		}
		if(@$distributor){
			$sql = $sql. " and sls.distributor_id=".$distributor;
		}
		$sql = $sql. " and container_id = 1";

 		$sql = $sql." group by sls.raw_account_id, acc.AccountID,acc.LongName,rep.ClientRepName  order by CE desc";
 		$data = $this->db->query($sql)->result_array();
        $geocode_array = array();
        $cnt = 0;
        $len=count($data);
        foreach ($data as $key => $account) {
            if($account['latitude']){
                $address = $account['address'];
                $name = $account['LongName'];
                $link = '<div class="sum2">'.'<a href="#/clientresult/'.$account["AccountID"].'">Go to Account</a></div>';
                $geocode_array[$cnt][0] = '<div class="summary">'.$name.'</div>'.'<br /><br />'.$address.'<br/><br/>'.$link;
                $geocode_array[$cnt][1] = $account['latitude'];
                $geocode_array[$cnt][2] = $account['longitude'];
                $cnt++;
            }
        }
 		if($data){
             $response = array(
                'status' => TRUE,
                'TopOffPremisereports' => $data,
                'locations' => $geocode_array,
                'len' => count($geocode_array)
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function TopDraft(){
    	$months = @$this->input->get('months');
    	$years  = @$this->input->get('years');
    	$distributor  = @$this->input->get('distributor');
    	if(!$months){
    		$this->db->select('default_month');
    		$months_array = @$this->db->get_where('ptsl_report_config',array("report_id"=>3))->result_array();
    		$months = $months_array[0]['default_month'];
    	}
    	if(!$years){
    		$this->db->select('default_year');
    		$years_array = @$this->db->get('ptsl_report_config',array("report_id"=>3))->result_array();
    		$years = $years_array[0]['default_year'];
    	}
    	if(!$distributor){
    		$this->db->select('default_distributor');
    		$distributor_array = @$this->db->get('ptsl_report_config',array("report_id"=>3))->result_array();
    		$distributor = $distributor_array[0]['default_distributor'];
    	}

    	$sql = "SELECT

                sls.raw_account_id,
                sls.raw_distributor_manager as manager,
                SUM(units) as units,

                acc.AccountID,
                acc.longitude,
                acc.latitude,
                acc.LongName,
                concat_ws(' ',acc.Address,acc.state,acc.City,acc.Zipcode) as address,

                rep.ClientRepName

				FROM ptsl_sales_transactions sls

				LEFT OUTER JOIN ptsl_accountinfo acc on acc.InternalAccountID = sls.raw_account_id

				LEFT OUTER JOIN ptsl_clientrep rep on rep.ClientRepID = sls.client_rep_id

				where sls.channel = 1";

		if(@$months){
			$sql = $sql." and month(ConvertedDate) in (".$months.")";
		}
		if(@$years){
			$sql = $sql." and YEAR(ConvertedDate) in (".$years.")";
		}
		if(@$distributor){
			$sql = $sql. " and sls.distributor_id=".$distributor;
		}
		$sql = $sql. " and container_id = 2";

 		$sql = $sql." group by sls.raw_account_id, acc.AccountID,acc.LongName,rep.ClientRepName  order by units desc";
 		$data = $this->db->query($sql)->result_array();
        $geocode_array = array();
        $cnt = 0;
        $len=count($data);
        foreach ($data as $key => $account) {
            if($account['latitude']){
                $address = $account['address'];
                $name = $account['LongName'];
                $link = '<div class="sum2">'.'<a href="#/clientresult/'.$account["AccountID"].'">Go to Account</a></div>';
                $geocode_array[$cnt][0] = '<div class="summary">'.$name.'</div>'.'<br /><br />'.$address.'<br/><br/>'.$link;
                $geocode_array[$cnt][1] = $account['latitude'];
                $geocode_array[$cnt][2] = $account['longitude'];
                $cnt++;
            }
        }
 		if($data){
             $response = array(
                'status' => TRUE,
                'TopDrafts' => $data,
                'locations' => $geocode_array,
                'len' => count($geocode_array)
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function brand_list(){
        $data = $this->db->get('ptsl_item_brand')->result_array();
        if($data){
             $response = array(
                'status' => TRUE,
                'brands' => $data,
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function report_by_brand(){
        $year = @$this->input->get('year');
        $brand_id  = @$this->input->get('brand_id');
        $sql = "SELECT brand,b.brand_name, sum(case_equivalents) CE, YEAR(ConvertedDate) as 'Year', QUARTER(ConvertedDate) 'Quarter' , concat('Qtr-',QUARTER(ConvertedDate)) as QuarterLabel

        from ptsl_sales_transactions sls

        left outer join ptsl_item_brand b on b.brand_id=sls.brand ";
        if(!$year && !$brand_id){
            $sql = $sql. "WHERE ConvertedDate > DATE_SUB(now(), INTERVAL 8 MONTH) ";
        } 
                
        if($year && !$brand_id){
            $sql = $sql. " where YEAR(ConvertedDate) = ".$year;
        }
        if($brand_id &&$year){
            $sql = $sql. " WHERE YEAR(ConvertedDate) =".$year. " and brand_id =".$brand_id;
        }         
        $sql = $sql." GROUP BY YEAR(ConvertedDate),QUARTER(ConvertedDate),brand,brand_name";

        $data = $this->db->query($sql)->result_array();
  
        $converted_array = array();
        $unique_brands = array();
        $color_array = array('#5C80B8','#B15751','#A2BA66','#7B669E');
        $dataset = array();
        $cdata = array();
        $labels = array();
        $has_done = false;
        $brand_ids = array();
        if($year && $brand_id){
        	foreach ($data as $key => $brand) {
        		array_push($dataset, $brand['CE']);
        	  	$brand_name = $brand['brand_name'];
        	}
        	$converted_array['labels'] = $labels;
        	$converted_array['datasets'] = $dataset;
        	$converted_array['colors'] = $color_array;
        	$converted_array['brand_name'] = (@$brand_name ? $brand_name : '');
        	$converted_array['fetched_data'] = $data;
        }

        if($converted_array){
             $response = array(
                'status' => TRUE,
                'brand_report' => $converted_array,
                'len' => count($converted_array)
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
 
   public function getdata(){
    $year = $this->input->get('year');
   	$color_array = array('#5C80B8','#B15751','#A2BA66','#7B669E');
   	$labels =array();
   	$brand_ids =array();
   	$quarter_1 =array();
   	$quarter_2 = array();
   	$quarter_3 =array();
   	$quarter_4 =array();
   	$sql="call ptsl_sp_sales_by_brand(?);";
   	$res = $this->db->query($sql,array($year))->result_array();
    $list_view = array();
    $list_view = array_slice($res, 0, -1);
   	foreach ($res as $key => $data) {
        if($data['brandID']==null){
            continue;
        }
   		array_push($labels,$data['brand_name']);
   		array_push($quarter_1,$data['Q_1']);
   		array_push($quarter_2,$data['Q_2']);
   		array_push($quarter_3,$data['Q_3']);
   		array_push($quarter_4,$data['Q_4']);
   	}
    $converted_array[0]['backgroundColor'] = $color_array[0];
    $converted_array[1]['backgroundColor'] = $color_array[1];
    $converted_array[2]['backgroundColor'] = $color_array[2];
    $converted_array[3]['backgroundColor'] = $color_array[3];
   	$converted_array[0]['data'] = $quarter_1;
   	$converted_array[1]['data'] = $quarter_2;
   	$converted_array[2]['data'] = $quarter_3;
   	$converted_array[3]['data'] = $quarter_4;
   	$converted_array[0]['label'] = 'Q1';
   	$converted_array[1]['label'] = 'Q2';
   	$converted_array[2]['label'] = 'Q3';
   	$converted_array[3]['label'] = 'Q4';
   	if($converted_array){
             $response = array(
                'status' => TRUE,
                'brand_report' => $converted_array,
                'len' => count($converted_array),
                'labels' => $labels,
                'fetched_data' => $list_view
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
   }
   public function get_brandfiterdata_init(){
   	$data = $this->db->get_where('ptsl_report_config',array('report_id'=>4))->result_array();
   	$default_month = $data[0]['default_month'];
   	$labels =array();
   	$jan =array();
   	$feb =array();
   	$mar =array();
   	$apr =array();
   	$may =array();
   	$jun =array();
   	$jul =array();
   	$aug =array();
   	$sep =array();
   	$oct =array();
   	$nov =array();
   	$dec =array();
   	$color_array = array('#5C80B8','#B15751','#A2BA66','#7B669E','#377E80','#8C1A06','#000000','#DC3EE4','#F19F27','#DDBEFC','#00007D','#996E31');
   	$spn = "Call ptsl_sp_sales_by_brand_initial_selected(?)";
   	$res = $this->db->query($spn,  array($default_month))->result_array();
   	$list_view = array();
   	$list_view = array_slice($res, 0, -1);
 	//reset( $list_view );
	//unset($list_view[key($list_view)]);
   	//print_r($list_view);
   	foreach ($res as $key => $data) {
        if($data['brandID']==null){
            continue;
        }
   		array_push($labels,$data['Brand']);
   		if (array_key_exists("January",$data)){
   			array_push($jan,$data['January']);
   		}
   		if (array_key_exists("February",$data)){
   			array_push($feb,$data['February']);
   		}
   		if (array_key_exists("March",$data)){
   			array_push($mar,$data['March']);
   		}
   		if (array_key_exists("April",$data)){
   			array_push($apr,$data['April']);
   		}
   		if (array_key_exists("May",$data)){
   			array_push($may,$data['May']);
   		}
   		if (array_key_exists("June",$data)){
   			array_push($jun,$data['June']);
   		}
   		if (array_key_exists("July",$data)){
   			array_push($jul,$data['July']);
   		}
   		if (array_key_exists("August",$data)){
   			array_push($aug,$data['August']);
   		}
   		if (array_key_exists("September",$data)){
   			array_push($sep,$data['September']);
   		}
   		if (array_key_exists("October",$data)){
   			array_push($oct,$data['October']);
   		}
   		if (array_key_exists("November",$data)){
   			array_push($nov,$data['November']);
   		}
   		if (array_key_exists("December",$data)){
   			array_push($dec,$data['December']);
   		}
   	
   	}
    	$freq =0;$freq2 =0;$freq3=0;$freq4=0;
  
    	if(sizeof($jan)!=0){
    		//echo 'here';
    		$converted_array[$freq++]['data'] =$jan;
    		$converted_array[$freq2++]['backgroundColor'] = $color_array[$freq3++];
    		$converted_array[$freq4++]['label'] = "Jan";
    	}
    	if(sizeof($feb)!=0){
    		$converted_array[$freq++]['data'] =$feb;
    		$converted_array[$freq2++]['backgroundColor'] = $color_array[$freq3++];
    		$converted_array[$freq4++]['label'] = "Feb";
    	}
    	if(sizeof($mar)!=0){
    		$converted_array[$freq++]['data'] =$mar;
    		$converted_array[$freq2++]['backgroundColor'] = $color_array[$freq3++];
    		$converted_array[$freq4++]['label'] = "Mar";
    	}
    	if(sizeof($apr)!=0){
    		$converted_array[$freq++]['data'] =$apr;
    		$converted_array[$freq2++]['backgroundColor'] = $color_array[$freq3++];
    		$converted_array[$freq4++]['label'] = "Apr";
    	}
    	if(sizeof($may)!=0){
    		$converted_array[$freq++]['data'] =$may;
    		$converted_array[$freq2++]['backgroundColor'] = $color_array[$freq3++];
    		$converted_array[$freq4++]['label'] = "May";
    	}
    	if(sizeof($jun)!=0){
    		$converted_array[$freq++]['data'] =$jun;
    		$converted_array[$freq2++]['backgroundColor'] = $color_array[$freq3++];
    		$converted_array[$freq4++]['label'] = "Jun";
    	}
    	if(sizeof($jul)!=0){
    		$converted_array[$freq++]['data'] =$jul;
    		$converted_array[$freq2++]['backgroundColor'] = $color_array[$freq3++];
    		$converted_array[$freq4++]['label'] = "Jul";
    	}
    	if(sizeof($aug)!=0){
    		$converted_array[$freq++]['data'] =$aug;
    		$converted_array[$freq2++]['backgroundColor'] = $color_array[$freq3++];
    		$converted_array[$freq4++]['label'] = "Aug";
    	}
    	if(sizeof($sep)!=0){
    		$converted_array[$freq++]['data'] =$sep;
    		$converted_array[$freq2++]['backgroundColor'] = $color_array[$freq3++];
    		$converted_array[$freq4++]['label'] = "Sep";
    	}
    	if(sizeof($oct)!=0){
    		$converted_array[$freq++]['data'] =$oct;
    		$converted_array[$freq2++]['backgroundColor'] = $color_array[$freq3++];
    		$converted_array[$freq4++]['label'] = "Oct";
    	}
    	if(sizeof($nov)!=0){
    		$converted_array[$freq++]['data'] =$nov;
    		$converted_array[$freq2++]['backgroundColor'] = $color_array[$freq3++];
    		$converted_array[$freq4++]['label'] = "Nov";
    	}
    	if(sizeof($dec)!=0){
    		$converted_array[$freq++]['data'] =$dec;
    		$converted_array[$freq2++]['backgroundColor'] = $color_array[$freq3++];
    		$converted_array[$freq4++]['label'] = "Dec";
    	}
    	
   		if($converted_array){
   			$response = array(
   				 'status' => TRUE,
   				 'brand_report' => $converted_array,
   				 'len' => count($converted_array),
   				 'labels' => $labels,
   				 'fetched_data' => $list_view
   				 );
   			echo json_encode($response);
   		}
   		else{
   			$response = array(
   				'status' => False,
   				 'message' => "No Data Found"
   			);
   			echo json_encode($response);
   		}
   	
   }
   public function report_bystate_init(){
        $data = $this->db->get_where('ptsl_report_config',array('report_id'=>5))->result_array();
        $default_month = $data[0]['default_month'];
        $labels =array();
        $jan =array();
        $feb =array();
        $mar =array();
        $apr =array();
        $may =array();
        $jun =array();
        $jul =array();
        $aug =array();
        $sep =array();
        $oct =array();
        $nov =array();
        $dec =array();
        $color_array = array('#5C80B8','#B15751','#A2BA66','#7B669E','#377E80','#8C1A06','#000000','#DC3EE4','#F19F27','#DDBEFC','#00007D','#996E31');
        $spn = "Call ptsl_sp_sales_by_state_initial(?)";
        $res = $this->db->query($spn,  array($default_month))->result_array();
        $list_view = array();
        $list_view = array_slice($res, 0, -1);
        
        foreach ($res as $key => $data) {
            if($data['State']==null){
                continue;
            }
            array_push($labels,$data['State']);
            if (array_key_exists("January",$data)){
                array_push($jan,$data['January']);
            }
            if (array_key_exists("February",$data)){
                array_push($feb,$data['February']);
            }
            if (array_key_exists("March",$data)){
                array_push($mar,$data['March']);
            }
            if (array_key_exists("April",$data)){
                array_push($apr,$data['April']);
            }
            if (array_key_exists("May",$data)){
                array_push($may,$data['May']);
            }
            if (array_key_exists("June",$data)){
                array_push($jun,$data['June']);
            }
            if (array_key_exists("July",$data)){
                array_push($jul,$data['July']);
            }
            if (array_key_exists("August",$data)){
                array_push($aug,$data['August']);
            }
            if (array_key_exists("September",$data)){
                array_push($sep,$data['September']);
            }
            if (array_key_exists("October",$data)){
                array_push($oct,$data['October']);
            }
            if (array_key_exists("November",$data)){
                array_push($nov,$data['November']);
            }
            if (array_key_exists("December",$data)){
                array_push($dec,$data['December']);
            }
        
        }
            $freq =0;$freq2 =0;$freq3=0;$freq4=0;
      
            if(sizeof($jan)!=0){
                //echo 'here';
                $converted_array[$freq++]['data'] =$jan;
                $converted_array[$freq2++]['backgroundColor'] = $color_array[$freq3++];
                $converted_array[$freq4++]['label'] = "Jan";
            }
            if(sizeof($feb)!=0){
                $converted_array[$freq++]['data'] =$feb;
                $converted_array[$freq2++]['backgroundColor'] = $color_array[$freq3++];
                $converted_array[$freq4++]['label'] = "Feb";
            }
            if(sizeof($mar)!=0){
                $converted_array[$freq++]['data'] =$mar;
                $converted_array[$freq2++]['backgroundColor'] = $color_array[$freq3++];
                $converted_array[$freq4++]['label'] = "Mar";
            }
            if(sizeof($apr)!=0){
                $converted_array[$freq++]['data'] =$apr;
                $converted_array[$freq2++]['backgroundColor'] = $color_array[$freq3++];
                $converted_array[$freq4++]['label'] = "Apr";
            }
            if(sizeof($may)!=0){
                $converted_array[$freq++]['data'] =$may;
                $converted_array[$freq2++]['backgroundColor'] = $color_array[$freq3++];
                $converted_array[$freq4++]['label'] = "May";
            }
            if(sizeof($jun)!=0){
                $converted_array[$freq++]['data'] =$jun;
                $converted_array[$freq2++]['backgroundColor'] = $color_array[$freq3++];
                $converted_array[$freq4++]['label'] = "Jun";
            }
            if(sizeof($jul)!=0){
                $converted_array[$freq++]['data'] =$jul;
                $converted_array[$freq2++]['backgroundColor'] = $color_array[$freq3++];
                $converted_array[$freq4++]['label'] = "Jul";
            }
            if(sizeof($aug)!=0){
                $converted_array[$freq++]['data'] =$aug;
                $converted_array[$freq2++]['backgroundColor'] = $color_array[$freq3++];
                $converted_array[$freq4++]['label'] = "Aug";
            }
            if(sizeof($sep)!=0){
                $converted_array[$freq++]['data'] =$sep;
                $converted_array[$freq2++]['backgroundColor'] = $color_array[$freq3++];
                $converted_array[$freq4++]['label'] = "Sep";
            }
            if(sizeof($oct)!=0){
                $converted_array[$freq++]['data'] =$oct;
                $converted_array[$freq2++]['backgroundColor'] = $color_array[$freq3++];
                $converted_array[$freq4++]['label'] = "Oct";
            }
            if(sizeof($nov)!=0){
                $converted_array[$freq++]['data'] =$nov;
                $converted_array[$freq2++]['backgroundColor'] = $color_array[$freq3++];
                $converted_array[$freq4++]['label'] = "Nov";
            }
            if(sizeof($dec)!=0){
                $converted_array[$freq++]['data'] =$dec;
                $converted_array[$freq2++]['backgroundColor'] = $color_array[$freq3++];
                $converted_array[$freq4++]['label'] = "Dec";
            }
            
            if($converted_array){
                $response = array(
                     'status' => TRUE,
                     'state_report' => $converted_array,
                     'len' => count($converted_array),
                     'labels' => $labels,
                     'fetched_data' => $list_view
                     );
                echo json_encode($response);
            }
            else{
                $response = array(
                    'status' => False,
                     'message' => "No Data Found"
                );
                echo json_encode($response);
            }
   }
   public function reportbyyear(){
    $year = $this->input->get('year');
    $color_array = array('#5C80B8','#B15751','#A2BA66','#7B669E');
    $labels =array();
    $brand_ids =array();
    $quarter_1 =array();
    $quarter_2 = array();
    $quarter_3 =array();
    $quarter_4 =array();
    $sql="call ptsl_sp_sales_by_state(?);";
    $res = $this->db->query($sql,array($year))->result_array();
    $list_view = array();
    $list_view = array_slice($res, 0, -1);
    foreach ($res as $key => $data) {
        if($data['raw_state']==null){
            continue;
        }
        array_push($labels,$data['raw_state']);
        array_push($quarter_1,$data['Q_1']);
        array_push($quarter_2,$data['Q_2']);
        array_push($quarter_3,$data['Q_3']);
        array_push($quarter_4,$data['Q_4']);
    }
    $converted_array[0]['backgroundColor'] = $color_array[0];
    $converted_array[1]['backgroundColor'] = $color_array[1];
    $converted_array[2]['backgroundColor'] = $color_array[2];
    $converted_array[3]['backgroundColor'] = $color_array[3];
    $converted_array[0]['data'] = $quarter_1;
    $converted_array[1]['data'] = $quarter_2;
    $converted_array[2]['data'] = $quarter_3;
    $converted_array[3]['data'] = $quarter_4;
    $converted_array[0]['label'] = 'Q1';
    $converted_array[1]['label'] = 'Q2';
    $converted_array[2]['label'] = 'Q3';
    $converted_array[3]['label'] = 'Q4';
    if($converted_array){
             $response = array(
                'status' => TRUE,
                'state_report' => $converted_array,
                'len' => count($converted_array),
                'labels' => $labels,
                'fetched_data' => $list_view
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
   }
    public function report_by_state_year(){
        $year = @$this->input->get('year');
        $brand_id  = @$this->input->get('state');
        $sql = "SELECT brand,raw_state, sum(case_equivalents) CE, YEAR(ConvertedDate) as 'Year', QUARTER(ConvertedDate) 'Quarter' , concat('Qtr-',QUARTER(ConvertedDate)) as QuarterLabel

        from ptsl_sales_transactions sls

        left outer join ptsl_item_brand b on b.brand_id=sls.brand ";
        if(!$year && !$brand_id){
            $sql = $sql. "WHERE ConvertedDate > DATE_SUB(now(), INTERVAL 8 MONTH) ";
        } 
                
        if($year && !$brand_id){
            $sql = $sql. " where YEAR(ConvertedDate) = ".$year;
        }
        if($brand_id &&$year){
            $sql = $sql. " WHERE YEAR(ConvertedDate) =".$year. " and raw_state ='".$brand_id."'";
        }         
        $sql = $sql." GROUP BY YEAR(ConvertedDate),QUARTER(ConvertedDate),raw_state";

        $data = $this->db->query($sql)->result_array();
        //print_r($data);
        $converted_array = array();
        $unique_brands = array();
        $color_array = array('#5C80B8','#B15751','#A2BA66','#7B669E');
        $dataset = array();
        $cdata = array();
        $labels = array();
        $has_done = false;
        $brand_ids = array();
        if($year && $brand_id){
            foreach ($data as $key => $brand) {
                array_push($dataset, $brand['CE']);
                $brand_name = $brand['raw_state'];
            }
            $converted_array['labels'] = $labels;
            $converted_array['datasets'] = $dataset;
            $converted_array['colors'] = $color_array;
            $converted_array['state'] = (@$brand_name ? $brand_name : '');
            $converted_array['fetched_data'] = $data;
        }

        if($converted_array){
             $response = array(
                'status' => TRUE,
                'brand_report' => $converted_array,
                'len' => count($converted_array)
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function channel_list(){
        $data = $this->db->get('ptsl_accountchannel')->result_array();
        if($data){
             $response = array(
                'status' => TRUE,
                'channel_list' => $data,
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function report_bypermise_init(){
        $user_id = $this->input->get('user_id');
        $data = $this->db->get_where('ptsl_report_config',array('report_id'=>5))->result_array();
        $default_month = $data[0]['default_month'];
        $labels =array();
        $jan =array();
        $feb =array();
        $mar =array();
        $apr =array();
        $may =array();
        $jun =array();
        $jul =array();
        $aug =array();
        $sep =array();
        $oct =array();
        $nov =array();
        $dec =array();
        $color_array = array('#5C80B8','#B15751','#A2BA66','#7B669E','#377E80','#8C1A06','#000000','#DC3EE4','#F19F27','#DDBEFC','#00007D','#996E31');
        $spn = "Call ptsl_sp_sales_by_premise_initial(?,?)";
        $res = $this->db->query($spn,array($default_month,$user_id))->result_array();
        $list_view = array();
        $list_view = array_slice($res, 0, -1);
        
        foreach ($res as $key => $data) {
            if($data['ChannelID']==null){
                continue;
            }
            array_push($labels,$data['Channel']);
            if (array_key_exists("January",$data)){
                array_push($jan,$data['January']);
            }
            if (array_key_exists("February",$data)){
                array_push($feb,$data['February']);
            }
            if (array_key_exists("March",$data)){
                array_push($mar,$data['March']);
            }
            if (array_key_exists("April",$data)){
                array_push($apr,$data['April']);
            }
            if (array_key_exists("May",$data)){
                array_push($may,$data['May']);
            }
            if (array_key_exists("June",$data)){
                array_push($jun,$data['June']);
            }
            if (array_key_exists("July",$data)){
                array_push($jul,$data['July']);
            }
            if (array_key_exists("August",$data)){
                array_push($aug,$data['August']);
            }
            if (array_key_exists("September",$data)){
                array_push($sep,$data['September']);
            }
            if (array_key_exists("October",$data)){
                array_push($oct,$data['October']);
            }
            if (array_key_exists("November",$data)){
                array_push($nov,$data['November']);
            }
            if (array_key_exists("December",$data)){
                array_push($dec,$data['December']);
            }
        
        }
            $freq =0;$freq2 =0;$freq3=0;$freq4=0;
      
            if(sizeof($jan)!=0){
                //echo 'here';
                $converted_array[$freq++]['data'] =$jan;
                $converted_array[$freq2++]['backgroundColor'] = $color_array[$freq3++];
                $converted_array[$freq4++]['label'] = "Jan";
            }
            if(sizeof($feb)!=0){
                $converted_array[$freq++]['data'] =$feb;
                $converted_array[$freq2++]['backgroundColor'] = $color_array[$freq3++];
                $converted_array[$freq4++]['label'] = "Feb";
            }
            if(sizeof($mar)!=0){
                $converted_array[$freq++]['data'] =$mar;
                $converted_array[$freq2++]['backgroundColor'] = $color_array[$freq3++];
                $converted_array[$freq4++]['label'] = "Mar";
            }
            if(sizeof($apr)!=0){
                $converted_array[$freq++]['data'] =$apr;
                $converted_array[$freq2++]['backgroundColor'] = $color_array[$freq3++];
                $converted_array[$freq4++]['label'] = "Apr";
            }
            if(sizeof($may)!=0){
                $converted_array[$freq++]['data'] =$may;
                $converted_array[$freq2++]['backgroundColor'] = $color_array[$freq3++];
                $converted_array[$freq4++]['label'] = "May";
            }
            if(sizeof($jun)!=0){
                $converted_array[$freq++]['data'] =$jun;
                $converted_array[$freq2++]['backgroundColor'] = $color_array[$freq3++];
                $converted_array[$freq4++]['label'] = "Jun";
            }
            if(sizeof($jul)!=0){
                $converted_array[$freq++]['data'] =$jul;
                $converted_array[$freq2++]['backgroundColor'] = $color_array[$freq3++];
                $converted_array[$freq4++]['label'] = "Jul";
            }
            if(sizeof($aug)!=0){
                $converted_array[$freq++]['data'] =$aug;
                $converted_array[$freq2++]['backgroundColor'] = $color_array[$freq3++];
                $converted_array[$freq4++]['label'] = "Aug";
            }
            if(sizeof($sep)!=0){
                $converted_array[$freq++]['data'] =$sep;
                $converted_array[$freq2++]['backgroundColor'] = $color_array[$freq3++];
                $converted_array[$freq4++]['label'] = "Sep";
            }
            if(sizeof($oct)!=0){
                $converted_array[$freq++]['data'] =$oct;
                $converted_array[$freq2++]['backgroundColor'] = $color_array[$freq3++];
                $converted_array[$freq4++]['label'] = "Oct";
            }
            if(sizeof($nov)!=0){
                $converted_array[$freq++]['data'] =$nov;
                $converted_array[$freq2++]['backgroundColor'] = $color_array[$freq3++];
                $converted_array[$freq4++]['label'] = "Nov";
            }
            if(sizeof($dec)!=0){
                $converted_array[$freq++]['data'] =$dec;
                $converted_array[$freq2++]['backgroundColor'] = $color_array[$freq3++];
                $converted_array[$freq4++]['label'] = "Dec";
            }
            
            if($converted_array){
                $response = array(
                     'status' => TRUE,
                     'premise_report' => $converted_array,
                     'len' => count($converted_array),
                     'labels' => $labels,
                     'fetched_data' => $list_view
                     );
                echo json_encode($response);
            }
            else{
                $response = array(
                    'status' => False,
                     'message' => "No Data Found"
                );
                echo json_encode($response);
            }
   }
   public function report_permise_by_year(){
    $year = $this->input->get('year');
    $sku = @$this->input->get('sku');
    $channel = @$this->input->get('channel');
    $brand = @$this->input->get('brand');
    $user_id = @$this->input->get('user_id');
    $state  = @$this->input->get('state');
    $quarter = @$this->input->get('quarter'); 
    $color_array = array('#5C80B8','#B15751','#A2BA66','#7B669E');
    $labels =array();
    $brand_ids =array();
    $quarter_1 =array();
    $quarter_2 = array();
    $quarter_3 =array();
    $quarter_4 =array();
    $sql="call ptsl_sp_sales_by_Premise(?,?,?,?,?,?,?);";
    $res = $this->db->query($sql,array($user_id,$year,$quarter,$channel,$brand,$sku,$state))->result_array();
    foreach ($res as $key => $data) {
        if($data['ChannelID']==null){
            continue;
        }
        array_push($labels,$data['Channel']);
        array_push($quarter_1,$data['Q_1']);
        array_push($quarter_2,$data['Q_2']);
        array_push($quarter_3,$data['Q_3']);
        array_push($quarter_4,$data['Q_4']);
    }
    $converted_array[0]['backgroundColor'] = $color_array[0];
    $converted_array[1]['backgroundColor'] = $color_array[1];
    $converted_array[2]['backgroundColor'] = $color_array[2];
    $converted_array[3]['backgroundColor'] = $color_array[3];
    $converted_array[0]['data'] = $quarter_1;
    $converted_array[1]['data'] = $quarter_2;
    $converted_array[2]['data'] = $quarter_3;
    $converted_array[3]['data'] = $quarter_4;
    $converted_array[0]['label'] = 'Q1';
    $converted_array[1]['label'] = 'Q2';
    $converted_array[2]['label'] = 'Q3';
    $converted_array[3]['label'] = 'Q4';
    if($converted_array){
             $response = array(
                'status' => TRUE,
                'premise_report' => $converted_array,
                'len' => count($converted_array),
                'labels' => $labels,
                'fetched_data' =>  array_slice($res, 0, -1)
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
   }
    public function report_by_permise_year_channel(){
        $year = $this->input->get('year');
    $sku = @$this->input->get('sku');
    $channel = @$this->input->get('channel');
    $brand = @$this->input->get('brand');
    $user_id = @$this->input->get('user_id'); 
    $color_array = array('#5C80B8','#B15751','#A2BA66','#7B669E');
    $labels =array();
    $brand_ids =array();
    $quarter_1 =array();
    $quarter_2 = array();
    $quarter_3 =array();
    $quarter_4 =array();
    $sql="call ptsl_sp_sales_by_Premise(?,?,?,?,?);";
    $res = $this->db->query($sql,array($user_id,$year,$channel,$brand,$sku))->result_array();
    foreach ($res as $key => $data) {
        if($data['ChannelID']==null){
            continue;
        }
        array_push($labels,$data['Channel']);
        array_push($quarter_1,$data['Q_1']);
        array_push($quarter_2,$data['Q_2']);
        array_push($quarter_3,$data['Q_3']);
        array_push($quarter_4,$data['Q_4']);
    }
    $converted_array[0]['backgroundColor'] = $color_array[0];
    $converted_array[1]['backgroundColor'] = $color_array[1];
    $converted_array[2]['backgroundColor'] = $color_array[2];
    $converted_array[3]['backgroundColor'] = $color_array[3];
    $converted_array[0]['data'] = $quarter_1;
    $converted_array[1]['data'] = $quarter_2;
    $converted_array[2]['data'] = $quarter_3;
    $converted_array[3]['data'] = $quarter_4;
    $converted_array[0]['label'] = 'Q1';
    $converted_array[1]['label'] = 'Q2';
    $converted_array[2]['label'] = 'Q3';
    $converted_array[3]['label'] = 'Q4';
    if($converted_array){
             $response = array(
                'status' => TRUE,
                'premise_report' => $converted_array,
                'len' => count($converted_array),
                'labels' => $labels,
                'fetched_data' =>  array_slice($res, 0, -1)
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
        /*$year = @$this->input->get('year');
        $channel  = @$this->input->get('channel');
        $sql = "SELECT brand,ch.ChannelName as Channel, sum(sales) CE, YEAR(ConvertedDate) as 'Year', QUARTER(ConvertedDate) 'Quarter' , concat('Qtr-',QUARTER(ConvertedDate)) as QuarterLabel

        from ptsl_sales_transactions sls

        left outer join ptsl_item_brand b on b.brand_id=sls.brand 
        join  ptsl_accountchannel ch on ch.accountChannelID=sls.Channel";
        
        if($channel &&$year){
            $sql = $sql. " WHERE YEAR(ConvertedDate) =".$year. " and Channel ='".$channel."'";
        }         
        $sql = $sql." GROUP BY YEAR(ConvertedDate),QUARTER(ConvertedDate),sls.Channel";

        $data = $this->db->query($sql)->result_array();
        //print_r($data);
        $converted_array = array();
        $unique_brands = array();
        $color_array = array('#5C80B8','#B15751','#A2BA66','#7B669E');
        $dataset = array();
        $cdata = array();
        $labels = array();
        $has_done = false;
        $brand_ids = array();
        if($year && $channel){
            foreach ($data as $key => $brand) {
                array_push($dataset, $brand['CE']);
                $brand_name = $brand['Channel'];
            }
            $converted_array['labels'] = $labels;
            $converted_array['datasets'] = $dataset;
            $converted_array['colors'] = $color_array;
            $converted_array['channel'] = (@$brand_name ? $brand_name : '');
            $converted_array['fetched_data'] = $data;
        }

        if($converted_array){
             $response = array(
                'status' => TRUE,
                'premise_report' => $converted_array,
                'len' => count($converted_array)
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }*/
    }
    public function sale_premise_filters(){
        $data['brands'] = $this->db->get('ptsl_item_brand')->result_array();
        $data['skus'] = $this->db->get('ptsl_item_packaging')->result_array();
        if($data){
             $response = array(
                'status' => TRUE,
                'filters' => $data,
                
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
}

